#!/bin/bash

git_dir="pki"
branch="100883"

function mail_send {
              echo "${message}"|mail -s "Attention! Certificate status!" \
              -S smtp=${SMTP_SERVER} \
              -S smtp-use-starttls \
              -S smtp-auth=login \
              -S ssl-verify=ignore \
              -S smtp-auth-user=$(cat /run/secrets/jenkins-mail-user) \
              -S smtp-auth-password=$(cat /run/secrets/jenkins-mail-pass) \
              -S nss-config-dir=/etc/pki/nssdb \
              -S from=$(cat /run/secrets/jenkins-mail-user) \
              ${RECIPIENT-MAIL-BOX}
}

if [ -d /${git_dir} ]
then
  cd /${git_dir} && GIT_SSH_COMMAND='ssh -i /run/secrets/provision-ssh-key -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no' \
  git pull && git checkout ${branch}
else
  cd / && GIT_SSH_COMMAND='ssh -i /run/secrets/provision-ssh-key -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no' \
  git clone ${git_url} && cd /${git_dir} && git checkout ${branch}
fi

if [ -z "$*" ]
then
  domain=$(echo "$*" | sed 's/ / -d /g')
  certbot certonly --dry-run --webroot -w /var/www/html --config-dir /${git_dir}/letsencrypt -d ${domain}
  if [ $? -eq 0 ]
  then
    cd /${git_dir} && GIT_SSH_COMMAND='ssh -i /run/secrets/provision-ssh-key -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no' git push origin ${branch}
    message="Certs for domain $(echo $*) is generated"
    mail_send
  else
    message="Certs for domain $(echo $*) isn't generated!!!"
    mail_send
  fi
fi
